package fr.atlantique.imt.inf211.jobmngt.entity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.Table;
import jakarta.persistence.UniqueConstraint;

@Entity
@Table(name = "appuser", schema = "public", uniqueConstraints = @UniqueConstraint(columnNames = "mail"))
public class AppUser implements java.io.Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY) // Correction ici
    @Column(name = "id", unique = true, nullable = false)
    private int id;

    @Column(name = "mail", unique = true, nullable = false, length = 50)
    private String mail;

    @Column(name = "password", nullable = false, length = 50)
    private String password;

    @Column(name = "city", length = 30) // Ajout car présent dans le script SQL
    private String city;

    public AppUser() {
    }

    public AppUser(int id, String mail, String password, String city) {
        this.id = id;
        this.mail = mail;
        this.password = password;
        this.city = city;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getMail() {
        return mail;
    }

    public void setMail(String mail) {
        this.mail = mail;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    @Override
    public String toString() {
        return "AppUser [id=" + id + ", mail=" + mail + ", city=" + city + "]";
    }
}
