package fr.atlantique.imt.inf211.jobmngt.entity;

import java.time.LocalDate;
import java.util.HashSet;
import java.util.Set;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "application", schema = "public")
public class Application implements java.io.Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY) // Changement ici
    private int id;

    @Column(name = "cv", nullable = false)
    private String cv;

    @Column(name = "appdate", nullable = false)
    private LocalDate appdate;

    @ManyToOne
    @JoinColumn(name = "candidateid", nullable = false)
    private Candidate candidate;

    @ManyToOne
    @JoinColumn(name = "qualiflevelid", nullable = false)
    private QualificationLevel qualificationLevel;

    @ManyToMany
    @JoinTable(name = "indexapplicationsector",
        joinColumns = @JoinColumn(name = "applicationid"),
        inverseJoinColumns = @JoinColumn(name = "sectorid"))
    private Set<Sector> sectors = new HashSet<>();

    public Application() {
    }

    // Getters & Setters
    public int getId() {
        return id;
    }

    public String getCv() {
        return cv;
    }

    public LocalDate getAppdate() {
        return appdate;
    }

    public Candidate getCandidate() {
        return candidate;
    }

    public QualificationLevel getQualificationLevel() {
        return qualificationLevel;
    }

    public Set<Sector> getSectors() {
        return sectors;
    }

    public void setId(int id) {
        this.id = id;
    }

    public void setCv(String cv) {
        this.cv = cv;
    }

    public void setAppdate(LocalDate appdate) {
        this.appdate = appdate;
    }

    public void setCandidate(Candidate candidate) {
        this.candidate = candidate;
    }

    public void setQualificationLevel(QualificationLevel qualificationLevel) {
        this.qualificationLevel = qualificationLevel;
    }

    public void setSectors(Set<Sector> sectors) {
        this.sectors = sectors;
    }
}
