package fr.atlantique.imt.inf211.jobmngt.entity;

import java.time.LocalDate;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "offermessage", schema = "public")
public class OfferMessage implements java.io.Serializable {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private int id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "jobofferid", nullable = false)
    private JobOffer jobOffer;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "applicationid", nullable = false)
    private Application application;

    @Column(name = "sentdate", nullable = false)
    private LocalDate sentdate = LocalDate.now();

    @Column(name = "message", nullable = false)
    private String message;

    public OfferMessage() {}

    public OfferMessage(JobOffer jobOffer, Application application, String message) {
        this.jobOffer = jobOffer;
        this.application = application;
        this.sentdate = LocalDate.now();
        this.message = message;
    }

    // Getters & Setters
    public int getId() {
        return id;
    }

    public JobOffer getJobOffer() {
        return jobOffer;
    }

    public Application getApplication() {
        return application;
    }

    public LocalDate getSentdate() {
        return sentdate;
    }

    public String getMessage() {
        return message;
    }

    public void setId(int id) {
        this.id = id;
    }

    public void setJobOffer(JobOffer jobOffer) {
        this.jobOffer = jobOffer;
    }

    public void setApplication(Application application) {
        this.application = application;
    }

    public void setSentdate(LocalDate sentdate) {
        this.sentdate = sentdate;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}
