package fr.atlantique.imt.inf211.jobmngt.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import fr.atlantique.imt.inf211.jobmngt.dao.CandidateDao;
import fr.atlantique.imt.inf211.jobmngt.entity.Candidate;

@Service
public class CandidateServiceImpl implements CandidateService {

    @Autowired
    private CandidateDao candidateDao;

    @Override
    public void saveCandidate(Candidate candidate) {
        candidateDao.persist(candidate);
    }

    @Override
    public void removeCandidate(Candidate candidate) {
        candidateDao.remove(candidate);
    }

    @Override
    public Candidate getCandidateById(int id) {
        return candidateDao.findById(id);
    }

    @Override
    public List<Candidate> listOfCandidates(String sort, String order) {
        return candidateDao.findAll(sort, order);
    }

    @Override
    public long countCandidates() {
        return candidateDao.count();
    }
}
