package fr.atlantique.imt.inf211.jobmngt.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import fr.atlantique.imt.inf211.jobmngt.dao.JobOfferDao;
import fr.atlantique.imt.inf211.jobmngt.entity.JobOffer;

@Service
public class JobOfferServiceImpl implements JobOfferService {

    @Autowired
    private JobOfferDao jobOfferDao;

    @Override
    public void saveJobOffer(JobOffer jobOffer) {
        jobOfferDao.persist(jobOffer);
    }

    @Override
    public void removeJobOffer(JobOffer jobOffer) {
        jobOfferDao.remove(jobOffer);
    }

    @Override
    public JobOffer getJobOfferById(int id) {
        return jobOfferDao.findById(id);
    }

    @Override
    public List<JobOffer> listOfJobOffers(String sort, String order) {
        return jobOfferDao.findAll(sort, order);
    }

    @Override
    public long countJobOffers() {
        return jobOfferDao.count();
    }
}
